package jartege ; 

import java.lang.reflect.* ; 
import java.util.* ; 

class Constituant {

   static boolean isVisible(Member member, String packageName, Class useClass) {
      int modifiers = member.getModifiers() ;
      if (Modifier.isPublic(modifiers)) {
         return true ; 
      } else if (Modifier.isProtected(modifiers)) {
         return useClass != null && 
                member.getDeclaringClass().isAssignableFrom(useClass) ; 
      } else if (Modifier.isPrivate(modifiers)) {
         return false ; 
      } else {
         Package thePackage = member.getDeclaringClass().getPackage() ; 
         if (thePackage == null) {
            return packageName == null ; 
         } else {
            return packageName != null && 
                   packageName.equals(thePackage.getName()) ; 
         }
      }
   }

   static boolean contientMethode(Set s, Method method) {
      Iterator it = s.iterator() ; 
      boolean trouve = false ; 
      Object[] typeParam = method.getParameterTypes() ; 
      while (it.hasNext() && !trouve) {
         Method cour = (Method) it.next() ; 
        
         if (cour.getName().equals(method.getName()) &&
             Arrays.equals(cour.getParameterTypes(), typeParam)) {
            trouve = true ; 
         }
      }
      return trouve ; 
   }
            
      

   public static Set getAllVisibleMethods(Class clas, Class useClass) {
      Package thePackage = useClass.getPackage() ; 
      if (thePackage == null) {
         return getAllVisibleMethods(clas, null, useClass) ; 
      } else {
         return getAllVisibleMethods(clas, thePackage.getName(), useClass) ; 
      }
   }

   public static Set getAllVisibleMethods(Class clas, String packageName) {
      Set result = getAllVisibleMethods(clas, packageName, null) ; 
      return result ; 
   }

   static Set getAllVisibleMethods
         (Class clas, String packageName, Class useClass) {
      Set result ; 
      if (clas == null) {
         result = new HashSet() ; 
      } else {
         result = getAllVisibleMethods
            (clas.getSuperclass(), packageName, useClass) ; 
         Method[] methods = clas.getDeclaredMethods() ; 
         for (int i = 0 ; i < methods.length ; i++) {
            Method method = methods[i] ; 
            if (isVisible(method, packageName, useClass) && 
                !contientMethode(result, method)) {
               result.add(method) ; 
            }
         }
      }

      return result ; 
   }

   public static Set getAllVisibleConstructors(Class clas, Class useClass) {
      Package thePackage = useClass.getPackage() ;
      if (thePackage == null) {
         return getAllVisibleConstructors(clas, null, useClass) ;
      } else {
         return getAllVisibleConstructors
            (clas, thePackage.getName(), useClass) ; 
      }
   }

   public static Set getAllVisibleConstructors(Class clas, String packageName) {
      return getAllVisibleConstructors(clas, packageName, null) ; 
   }

   static Set getAllVisibleConstructors(Class clas, String packageName, Class useClass) {

      Set result = new HashSet() ; 

      Constructor[] constructors = clas.getDeclaredConstructors() ; 
      for (int i = 0 ; i < constructors.length ; i++) {
         Constructor cons = constructors[i] ; 
         if (isVisible(cons, packageName, useClass)) {
            result.add(cons) ; 
         }
      }

      return result ; 
   }


   public static Set getAllVisibleFields(Class clas, Class useClass) {
      Package thePackage = useClass.getPackage() ;
      if (thePackage == null) {
         return getAllVisibleFields(clas, null, useClass) ;
      } else {
         return getAllVisibleFields(clas, thePackage.getName(), useClass) ;
      }
   }

   public static Set getAllVisibleFields(Class clas, String packageName) {
      return getAllVisibleFields(clas, packageName, null) ;
   }


   static Set getAllVisibleFields(Class clas, String packageName, Class useClass) {

      Set result ; 

      if (clas == null) {
         result = new HashSet() ; 
      } else {
         result = getAllVisibleFields(clas.getSuperclass(), 
                                      packageName, useClass) ; 

         Field[] fields = clas.getDeclaredFields() ; 
         for (int i = 0 ; i < fields.length ; i++) {
            Field field = fields[i] ; 
            if (isVisible(field, packageName, useClass) && 
                !result.contains(field)) {
               result.add(field) ; 
            }
         }
      }

      return result ; 
   }

}

