package jartege ; 

/**
 * The interface CreationProbability allows one to define creation
 * probability functions. A creation probability function gives the
 * probability of creation of a new object in function of the number
 * of already created objects.
 *
 * @author Catherine Oriat
 */

public interface CreationProbability {

   /**
    * The creation probability function. <br>
    * Precondition : <code>nbCreatedObjected >= 0</code><br>
    * Postcondition : <code>theFunction(nbCreatedObjects)</code> is in 
    * <code>[0, 1]</code>.
    *
    * @param nbCreatedObjects the number of already created objects.
    */
 
   double theFunction(int nbCreatedObjects) ; 

}

      
