package jartege ; 

import java.lang.reflect.* ; 
import java.util.* ; 
import java.io.* ; 

/**
 * Classe des mthodes.
 */

class Methode extends Operation {

   // L'objet de type Method reprsent par cette mthode
   Method theMethod ; 
   
   // Constructeur
   Methode(Method theMethod, Classe laClasse) {
      super(laClasse) ; 
      setNomComplet(theMethod.getName()) ; 
      this.theMethod = theMethod ; 
      calculeVecteurMGP() ; 
   }

   // Le type des paramtres de cette mthode
   Class[] typeParametres() {
      return theMethod.getParameterTypes() ; 
   }

   // Le type de retour de cette mthode
   Class typeRetour() {
      return theMethod.getReturnType() ; 
   }

   boolean estStatique() {
      return Modifier.isStatic(theMethod.getModifiers()) ; 
   }

   Class[] typesExceptions() {
      return theMethod.getExceptionTypes() ; 
   }

   /**
    * Evaluation d'un appel de cette methode.
    */
   
   Object eval(Appel appel) throws  // InstantiationException,
                          IllegalAccessException,
                          IllegalArgumentException,
                          InvocationTargetException {
      return theMethod.invoke(
                appel.getValeurParamImpl(), appel.getValeurTabParam()) ; 
   }

   /**
    * Chaine de caractres correspondant  cet appel.
    */

   String toString(Appel appel) {
      String res = "" ;
      if (estStatique()) {
         res = res + laClasse.getNom() ;
      } else if (appel.getParamImpl() != null) {
         res = res + appel.getParamImpl().toString() ; 
      } else {
         res = res + "null" ;
      }
      res = res + "." + getNom() + "(" ;
      Expression[] param = appel.getTabParam() ; 
      for (int i = 0 ; i < param.length ; i++) {
         if (i != 0) {
            res = res + ", " ;
         }
         // PATCH !
         if (param[i] == null) {
            res = res + "[null]" ; 
         } else {
            res = res + param[i].toString() ;
         }
      }
      res = res + ")" ;
      return res ;
   }

}

