package jartege ; 

import java.util.* ; 

/**
 * Class of selections. 
 * A selection is a size specification which corresponds to a 
 * choice of constructors.
 */

class Selection extends Size {

   // Contient la liste des constructeurs qu'on peut utiliser pour 
   // construire un objet
   // A chaque constructeur est associe une somme qui indique comment
   // calculer la taille d'un objet construit avec ce constructeur
   Map constructorToSum ; 

   // Est vrai ssi on peut generer un objet egal a null
   boolean containsNull ; 

   // The class associated with this selection
   Classe theClass ; 

   /**
    * Constructeur.
    */
   Selection(boolean containsNull, Classe theClass) {
      Trace.afficher(2, "Selection(" + containsNull + ", " + 
         theClass.getNomComplet() + ") ->") ; 
      this.containsNull = containsNull ; 
      this.theClass = theClass ;
      constructorToSum = new HashMap() ; 
      List lesCons = theClass.lesConstructeurs ; 
      Iterator it = lesCons.iterator() ; 
      while (it.hasNext()) {
         Constructeur cons = (Constructeur) (it.next()) ; 
         Trace.afficher(2, "Constructeur " + cons.getNomComplet() + " ajoute") ; 
         constructorToSum.put(cons, new Sum(1, cons)) ; 
      }
      Trace.afficher(2, "Selection(" + containsNull + ", " + 
         theClass.getNomComplet() + ") <-") ; 

   }

   /**
    * Nombre d'objets de taille i que l'on peut construire en utilisant 
    * un des constructeurs
    */
   int calcNumber(int i) {
      // Coder le calcul de n_i
      return 0 ; 
   }

}


