package jartege ; 

/**
 * Utilitary class.
 */

public class Util {

   /**
    * Returns the Class object corresponding to the class with the specified 
    * class name.
    * Prints an error message and exits if the class is not found.
    *
    * @param className the name of the class.
    */

   public static Class forName(String className) {
      Class result = null ; 
      if (className.equals("int") || className.equals("java.lang.int")) {
         return Integer.TYPE ; 
      } else if (className.equals("long") || 
                 className.equals("java.lang.long")) {
         return Long.TYPE ; 
      } else if (className.equals("short") || 
                 className.equals("java.lang.short")) {
         return Short.TYPE ; 
      } else if (className.equals("byte") || 
                 className.equals("java.lang.byte")) {
         return Byte.TYPE ; 
      } else if (className.equals("char") || 
                 className.equals("java.lang.char")) {
         return Character.TYPE ; 
      } else if (className.equals("boolean") || 
                 className.equals("java.lang.boolean")) {
         return Boolean.TYPE ; 
      } else if (className.equals("float") || 
                 className.equals("java.lang.float")) {
         return Float.TYPE ; 
      } else if (className.equals("double") || 
                 className.equals("java.lang.double")) {
         return Double.TYPE ; 
      } else {
         try {
            result = Class.forName(className) ; 
         } catch (ClassNotFoundException except) {
            ErrorMessage.classNotFound(className) ; 
         } catch (LinkageError except) {
            ErrorMessage.classLinkageError(className) ; 
         }
         return result ; 
      }
   }
}

